/* aufgabe_ls4_01.sql - Aufgaben für den Umgang mit SQL (I) - Daten aus einer Tabelle anzeigen
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  19.03.2021, 21.06.2022
*/

/* Datenbank auswählen */
USE w3schools;

/* a) Für alle Lieferanten (supplier) die ID, den Namen und das Land ausgeben */
SELECT
    SupplierID,
    SupplierName,
    Country
FROM
    suppliers;

/* b) Alle Daten alle Spediteure (shipper) ausgeben */
SELECT
    *
FROM
    shippers;

/* c) ID, Name und Kontaktname aller Lieferanten ausgeben, deren ID  kleiner gleich 20 ist */
SELECT
    SupplierID,
    SupplierName,
    ContactName
FROM
    suppliers
WHERE
    SupplierID <= 20;

/* d) ID, Name und Kontaktname aller Lieferanten ausgeben, deren Name ein "y" vorkommt */
SELECT
    SupplierID,
    SupplierName,
    ContactName
FROM
    suppliers
WHERE
    SupplierName LIKE "%y%";

/* e) Alphabetisch sortiert alle Länder ohne doppelte ausgeben, in denen es Lieferanten gibt */
SELECT
    DISTINCT Country
FROM
    suppliers
ORDER BY
    Country;

/* f) Alphabetisch rückwärts sortiert nach Nachnamen alle Mitarbeiter (employee) ausgeben, die vor dem 1.1.1960 geboren sind */
SELECT
    *
FROM
    Employees
WHERE
    BirthDate < "1960-01-01"
ORDER BY
    LastName DESC;

/* g) Alphabetisch rückwärts sortiert nach Nachnamen alle Mitarbeiter (employee) ausgeben, die vor dem 1.1.1960 geboren sind
 und in deren Nach- oder Vornamen ein "u" vorkommt */
SELECT
    *
FROM
    employees
WHERE
    BirthDate < "1960-01-01"
    AND(
        LastName LIKE "%u%"
        OR FirstName LIKE "%u%"
    )
ORDER BY
    LastName DESC;
