/* aufgabe_ls4_03.sql - Aufgaben für den Umgang mit SQL (III) - Daten aus mehreren Tabelle kombinieren (joins)
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  24.03.2021, 09.05.2023
*/
/* Datenbank auswählen */
USE w3schools;
/* Vorbereitung */
INSERT INTO
  suppliers (SupplierName)
VALUES
  ("Lieferant 1"),
  ("Lieferant 2"),
  ("Lieferant 3");
INSERT INTO
  shippers (ShipperName)
VALUES
  ("Spediteur 1"),
  ("Spediteur 2"),
  ("Spediteur 3");
INSERT INTO
  employees (FirstName, LastName)
VALUES
  ("Fauler", "Sack 1"),
  ("Fauler", "Sack 2"),
  ("Fauler", "Sack 3");
  /* a) Zeigen Sie alle Lieferanten und ihre Produkte  (jeweils Name) an.
   Lieferanten, die nichts liefern sollen nicht angezeigt werden (INNER JOIN) */
SELECT
  suppliers.SupplierName,
  products.ProductName
FROM
  suppliers
  INNER JOIN products ON suppliers.SupplierID = products.SupplierID;
  /* b) Zeigen Sie alle Lieferanten und ihre Produkte  (jeweils Name) an.
   Lieferanten, die nichts liefern sollen mit angezeigt werden (LEFT JOIN) */
SELECT
  suppliers.SupplierName,
  products.ProductName
FROM
  suppliers
  LEFT JOIN products ON suppliers.SupplierID = products.SupplierID;
  /* c) Zeigen Sie alle Lieferanten und ihre Produkte  (jeweils Name) an.
   Lieferanten, die nichts liefern sollen mit angezeigt werden (RIGHT JOIN) */
SELECT
  suppliers.SupplierName,
  products.ProductName
FROM
  products
  RIGHT JOIN suppliers ON products.SupplierID = suppliers.SupplierID;
  /* d) Zeigen Sie alle Spediteure (Name) und die von ihnen transportierten Bestellungen  (ID, Datum) an.
   Spediteuere, die nichts transportiert haben sollen angezeigt werden  */
SELECT
  shippers.ShipperName,
  orders.OrderID,
  orders.OrderDate
FROM
  shippers
  LEFT JOIN orders ON shippers.ShipperID = orders.ShipperID;
  /* e) Zeigen Sie alle Spediteure (Name) und die von ihnen transportierten Bestellungen  (ID, Datum) an.
   Spediteuere, die nichts transportiert haben sollen nicht angezeigt werden  */
SELECT
  shippers.ShipperName,
  orders.OrderID,
  orders.OrderDate
FROM
  shippers
  INNER JOIN orders ON shippers.ShipperID = orders.ShipperID;
  /* f) Zeigen Sie alle Mitarbeiter (Nachname, Vorname) und die von ihnen bearbeiteten Bestellungen (ID, Datum) an.
   Mitarbeiter, die nichts getan haben sollen angezeigt werden  */
SELECT
  employees.LastName,
  employees.FirstName,
  orders.OrderID,
  orders.OrderDate
FROM
  employees
  LEFT JOIN orders ON employees.EmployeeID = orders.EmployeeID;
  /* g) Zeigen Sie alle Mitarbeiter (Nachname, Vorname), die von ihnen bearbeiteten Bestellungen (ID, Datum)
   und den Namen des Kunden an, der die jeweilige Bestellung getätigt hat.
   Mitarbeiter, die nichts getan haben sollen angezeigt werden  */
SELECT
  employees.LastName,
  employees.FirstName,
  orders.OrderID,
  orders.OrderDate,
  customers.CustomerName
FROM
  employees
  LEFT JOIN orders ON employees.EmployeeID = orders.EmployeeID
  LEFT JOIN customers ON orders.CustomerID = customers.CustomerID;
  /* h) Zeigen Sie alle Mitarbeiter (Nachname, Vorname) und den Namen der von dem jeweiligen Mitarbeiter
   bearbeiteten Kunden an. Mitarbeiter, die nichts getan haben sollen angezeigt werden. Es soll keine
   doppelten Einträge geben und die Ausgabe soll nach Kundenname sortiert sein. */
SELECT
  DISTINCT employees.LastName,
  employees.FirstName,
  customers.CustomerName
FROM
  employees
  LEFT JOIN orders ON employees.EmployeeID = orders.EmployeeID
  LEFT JOIN customers ON orders.CustomerID = customers.CustomerID
ORDER BY
  CustomerName;
  /* i) Zeigen Sie den Namen und Kontaktnamen aller Lieferanten an, die Produkte der Kategorie
   mit dem Namen "Seafood" liefern. Zusätzlich soll der jeweilige Produktname angezeigt werden */
SELECT
  products.ProductName,
  suppliers.SupplierName,
  suppliers.ContactName
FROM
  categories
  LEFT JOIN products ON categories.CategoryID = products.CategoryID
  LEFT JOIN suppliers ON products.SupplierID = suppliers.SupplierID
WHERE
  CategoryName LIKE "Seafood";
  /* j) Zeigen Sie den Namen und Kontaktnamen aller Kunden an, die Produkte der Kategorie
   mit dem Namen "Seafood" bestellt haben. Zusätzlich soll der jeweilige Produktname angezeigt werden */
SELECT
  customers.CustomerName,
  customers.ContactName,
  products.Productname
FROM
  categories
  LEFT JOIN products ON categories.CategoryID = products.CategoryID
  LEFT JOIN order_details ON products.ProductID = order_details.ProductID
  LEFT JOIN orders ON order_details.OrderID = orders.OrderID
  LEFT JOIN customers ON orders.CustomerID = customers.CustomerID
WHERE
  CategoryName LIKE "Seafood";