/* aufgabe_ls4_04.sql - Aufgaben für den Umgang mit SQL (IV)
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  28.03.2021, 09.05.2023
*/

/* Datenbank auswählen */
USE w3schools;

/* a) Zeigen Sie alle Bestellungen mit ID, Datum, Name des Kunden
 und Nachnamen des bearbeitenden Mitarbeits an */
SELECT
    orders.OrderID,
    orders.OrderDate,
    customers.CustomerName,
    employees.LastName
FROM
    orders
    INNER JOIN customers ON orders.CustomerID = customers.CustomerID
    INNER JOIN employees ON orders.EmployeeID = employees.EmployeeID;

/* b) Zeigen Sie Anzahl aller Bestellungen an */
SELECT
    COUNT(*)
FROM
    orders;

/* c) Zeigen Sie Anzahl aller Bestellungen an die Mitarbeiter "Fuller" (Nachname) bearbeitet hat */
SELECT
    COUNT(*)
FROM
    orders
    INNER JOIN employees ON orders.EmployeeID = employees.EmployeeID
WHERE
    Lastname LIKE "Fuller";

/* d) Zeigen Sie den minimalen, maximalen und durchschnittlichen Preis
 aller Produkte an  */
SELECT
    MIN(Price) AS "Minimaler Preis",
    MAX(Price) AS "Maximaler Preis",
    ROUND(AVG(Price), 2) AS "Durchschnittlicher Preis"
FROM
    products;

/* e) Zeigen Sie die Anzahl, den minimalen, maximalen und durchschnittlichen Preis
 aller Produkte der Kategorie mit der ID 5 an */
SELECT
    COUNT (PRICE) AS "Anzahl",
    MIN(Price) AS "Minimaler Preis",
    MAX(Price) AS "Maximaler Preis",
    ROUND(AVG(Price), 2) AS "Durchschnittlicher Preis"
FROM
    products
WHERE
    CategoryID = 5;

/* f) Geben Sie die Produktnamen und Kategorie ID aller Produkte aus */
SELECT
    ProductName,
    CategoryID
FROM
    products;

/* g) Geben Sie die Kategorie ID und die Anzahl der Produkte je KategrorieID aus */
SELECT
    CategoryID,
    COUNT (*) AS Produktanzahl
FROM
    products
    GROUP BY CategoryID;

/* h) Geben Sie den Kategorienamen und die Anzahl der Produkte je Kategrorie aus */
SELECT
    categories.CategoryName,
    COUNT (*)
FROM
    products
    INNER JOIN categories on products.CategoryID = categories.CategoryID
    GROUP BY products.CategoryID    ;