/* aufgabe_ls4_05.sql - Datenbank KFZ-Zulassungsstelle
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  03.04.2021, 21.06.2022
*/

DROP DATABASE IF EXISTS aufgabe_ls4_05;
# Evtl. vorhandene Datenbank löschen
CREATE DATABASE aufgabe_ls4_05 DEFAULT CHARACTER SET utf8;
# Neue Beispieldatenbank anlegen
USE aufgabe_ls4_05;
# Mit neuer Datenbank verbinden
/* Tabellen anlegen */
CREATE TABLE plz (
  plzID INT(11) NOT NULL AUTO_INCREMENT,
  PLZ VARCHAR(10) DEFAULT NULL,
  Ort VARCHAR(255) DEFAULT NULL,
  PRIMARY KEY (plzID)
);
CREATE TABLE eigentuemer (
  EigentuemerID INT(11) NOT NULL AUTO_INCREMENT,
  Name VARCHAR(255) DEFAULT NULL,
  Vorame VARCHAR(255) DEFAULT NULL,
  Geburtsdatum date DEFAULT NULL,
  Strasse VARCHAR(255) DEFAULT NULL,
  plzID INT(11) NOT NULL,
  PRIMARY KEY (EigentuemerID),
  FOREIGN KEY (plzID) REFERENCES plz (plzID)
);
CREATE TABLE typen (
  TypID INT(11) NOT NULL AUTO_INCREMENT,
  Hersteller VARCHAR(255) DEFAULT NULL,
  Modell VARCHAR(255) DEFAULT NULL,
  Schadstoffklasse VARCHAR(255) DEFAULT NULL,
  PRIMARY KEY (TypID)
);
CREATE TABLE fahrzeuge (
  FahrzeugeID INT(11) NOT NULL AUTO_INCREMENT,
  Fahrgestellnummer VARCHAR(255) DEFAULT NULL,
  Baujahr INT (4) DEFAULT NULL,
  TypID INT (11),
  EigentuemerID INT (11),
  PRIMARY KEY (FahrzeugeID),
  FOREIGN KEY (TypID) REFERENCES typen (TypID),
  FOREIGN KEY (EigentuemerID) REFERENCES eigentuemer (EigentuemerID)
);
CREATE TABLE zulassungen (
  ZulassungsID INT(11) NOT NULL AUTO_INCREMENT,
  Kennzeichen VARCHAR(20) DEFAULT NULL,
  Zulassungsdatum DATE DEFAULT NULL,
  Abmeldedatum DATE DEFAULT NULL,
  FahrzeugeID INT (4),
  PRIMARY KEY (ZulassungsID),
  FOREIGN KEY (FahrzeugeID) REFERENCES fahrzeuge (FahrzeugeID),
  CONSTRAINT datumsregel CHECK (Abmeldedatum > Zulassungsdatum)
);