-- Active: 1708945050417@@127.0.0.1@3306@aufgabe_ls4_08
/* aufgabe_ls4_08.sql - Datenbank Hundedaten
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  30.04.2024
*/

# Datenbank anlegen
DROP DATABASE IF EXISTS aufgabe_ls4_08;
CREATE DATABASE aufgabe_ls4_08 DEFAULT CHARACTER SET utf8;

 
USE aufgabe_ls4_08;

/* Tabellen anlegen */
CREATE TABLE halter (
  halterID INT(11) NOT NULL AUTO_INCREMENT,
  nachname VARCHAR(255) DEFAULT NULL,
  vorname VARCHAR(255) DEFAULT NULL,
  geburtsdatum date DEFAULT NULL,
  PRIMARY KEY (halterID)
);
CREATE TABLE rassen (
  rasseID INT(11) NOT NULL AUTO_INCREMENT,
  name VARCHAR(255) DEFAULT NULL,
  PRIMARY KEY (rasseID)
);
CREATE TABLE hunde (
  hundeID INT(11) NOT NULL AUTO_INCREMENT,
  name VARCHAR(255) DEFAULT NULL,
  geburtsdatum date DEFAULT NULL,
  geschlecht VARCHAR(5) DEFAULT NULL,
  halterID INT (11),
  rasseID INT (11),
  PRIMARY KEY (hundeID),
  FOREIGN KEY (halterID) REFERENCES halter (halterID),
  FOREIGN KEY (rasseID) REFERENCES rassen (rasseID)
);

# a) 
INSERT INTO rassen (name) 
  Values 
    ("Border Collie"), 
    ("Australian Sheppard"), 
    ("Dackel"), 
    ("Deutscher Schäferhund");

# b)
UPDATE rassen 
  SET
    name = "Belgischer Schäferhund"
  WHERE
    name = "Deutscher Schäferhund";

# c)
SELECT *
  FROM rassen
  ORDER BY name;

# d)
DELETE
  FROM rassen
  WHERE
    name = "Dackel";

# e)
INSERT INTO halter (nachname,vorname,geburtsdatum)
  VALUES
    ("Nord", "Nobert", "2001-01-01"),
    ("Süd", "Sarah", "2002-02-02"),
    ("West", "Werner", "2003-03-03"),
    ("Ost", "Olga", "2004-04-04");

SELECT *
  FROM halter;

# f)
SELECT nachname, vorname
  FROM halter
  WHERE
    nachname LIKE "S%";

# g)
INSERT INTO hunde (name,geburtsdatum,geschlecht,halterID,rasseID)
  VALUES
    ("Floss",  "2020-01-01", "W",1,1),
    ("Hasso", "2020-02-02", "M",1,4),
    ("Ice",  "2020-03-03", "M",3,1),
    ("Bella", "2020-04-04", "W",3,2);

SELECT halter.nachname, halter.vorname, hunde.name, rassen.name
  FROM
    halter
  INNER JOIN hunde ON halter.halterID = hunde.halterID
  INNER JOIN rassen ON hunde.rasseID = rassen.rasseID;